/* parser */
%token <int> INT
%token PLUS MINUS TIMES DIV
%token LPAREN RPAREN
%token EOL
%left PLUS MINUS /* minimal precedence */
%left TIMES DIV  /* higher precedence */

%start main
%type <int> main

%%

main:
	expr EOL				{ $1 }
;

expr:
	  INT					{ $1 }
	| LPAREN expr RPAREN			{ $2 }
	| PLUS expr expr			{ $2 + $3 }
	| MINUS expr expr			{ $2 - $3 }
	| TIMES expr expr			{ $2 * $3 }
	| DIV expr expr				{ $2 / $3 }
;
